# GstBaseSink

GstBaseSink is the base class for sink elements in GStreamer, such as xvimagesink or filesink. It is a layer on top of GstElement that provides a simplified interface to plugin writers. GstBaseSink handles many details for you, for example: preroll, clock synchronization, state changes, activation in push or pull mode, and queries.

In most cases, when writing sink elements, there is no need to implement class methods from GstElement or to set functions on pads, because the GstBaseSink infrastructure should be sufficient.

GstBaseSink provides support for exactly one sink pad, which should be named "sink". A sink implementation (subclass of GstBaseSink) should install a pad template in its class_init function, like so:

     static void
     my_element_class_init (GstMyElementClass *klass)
     {
       GstElementClass *gstelement_class = GST_ELEMENT_CLASS (klass);

       // sinktemplate should be a #GstStaticPadTemplate with direction
       // %GST_PAD_SINK and name "sink"
       gst_element_class_add_static_pad_template (gstelement_class, &sinktemplate);

       gst_element_class_set_static_metadata (gstelement_class,
           "Sink name",
           "Sink",
           "My Sink element",
           "The author <my.sink@my.email>");
     }

GstBaseSink will handle the prerolling correctly. This means that it will return GST_STATE_CHANGE_ASYNC from a state change to PAUSED until the first buffer arrives in this element. The base class will call the preroll vmethod with this preroll buffer and will then commit the state change to the next asynchronously pending state.

When the element is set to PLAYING, GstBaseSink will synchronise on the clock using the times returned from get_times. If this function returns GST_CLOCK_TIME_NONE for the start time, no synchronisation will be done. Synchronisation can be disabled entirely by setting the object sync property to FALSE.

After synchronisation the virtual method render will be called. Subclasses should minimally implement this method.

Subclasses that synchronise on the clock in the render method are supported as well. These classes typically receive a buffer in the render method and can then potentially block on the clock while rendering. A typical example is an audiosink. These subclasses can use gst_base_sink_wait_preroll to perform the blocking wait.

Upon receiving the EOS event in the PLAYING state, GstBaseSink will wait for the clock to reach the time indicated by the stop time of the last get_times call before posting an EOS message. When the element receives EOS in PAUSED, preroll completes, the event is queued and an EOS message is posted when going to PLAYING.

GstBaseSink will internally use the GST_EVENT_SEGMENT events to schedule synchronisation and clipping of buffers. Buffers that fall completely outside of the current segment are dropped. Buffers that fall partially in the segment are rendered (and prerolled). Subclasses should do any subbuffer clipping themselves when needed.

GstBaseSink will by default report the current playback position in GST_FORMAT_TIME based on the current clock time and segment information. If no clock has been set on the element, the query will be forwarded upstream.

The set_caps function will be called when the subclass should configure itself to process a specific media type.

The start and stop virtual methods will be called when resources should be allocated. Any preroll, render and set_caps function will be called between the start and stop calls.

The event virtual method will be called when an event is received by GstBaseSink. Normally this method should only be overridden by very specific elements (such as file sinks) which need to handle the newsegment event specially.

The unlock method is called when the elements should unblock any blocking operations they perform in the render method. This is mostly useful when the render method performs a blocking write on a file descriptor, for example.

The max-lateness property affects how the sink deals with buffers that arrive too late in the sink. A buffer arrives too late in the sink when the presentation time (as a combination of the last segment, buffer timestamp and element base_time) plus the duration is before the current time of the clock. If the frame is later than max-lateness, the sink will drop the buffer without calling the render method. This feature is disabled if sync is disabled, the get_times method does not return a valid start time or max-lateness is set to -1 (the default). Subclasses can use gst_base_sink_set_max_lateness to configure the max-lateness value.

The qos property will enable the quality-of-service features of the basesink which gather statistics about the real-time performance of the clock synchronisation. For each buffer received in the sink, statistics are gathered and a QOS event is sent upstream with these numbers. This information can then be used by upstream elements to reduce their processing rate, for example.

The async property can be used to instruct the sink to never perform an ASYNC state change. This feature is mostly usable when dealing with non-synchronized streams or sparse streams.

## GstBaseSink

    GObject
        ╰──GInitiallyUnowned
            ╰──GstObject
                ╰──GstElement
                    ╰──GstBaseSink

The opaque GstBaseSink data structure.

### Members

`element` (GstElement) –
No description available
`sinkpad` (GstPad *) –
No description available
`pad_mode` (GstPadMode) –
No description available
`offset` (guint64) –
No description available
`can_activate_pull` (gboolean) –
No description available
`can_activate_push` (gboolean) –
No description available
`preroll_lock` (GMutex) –
No description available
`preroll_cond` (GCond) –
No description available
`eos` (gboolean) –
No description available
`need_preroll` (gboolean) –
No description available
`have_preroll` (gboolean) –
No description available
`playing_async` (gboolean) –
No description available
`have_newsegment` (gboolean) –
No description available
`segment` (GstSegment) –
No description available

### Class structure

#### GstBaseSinkClass

Subclasses can override any of the available virtual methods or not, as needed. At the minimum, the render method should be overridden to output/present buffers.

##### Fields

`parent_class` (GstElementClass) –

Element parent class

### GstBase.BaseSinkClass

Subclasses can override any of the available virtual methods or not, as needed. At the minimum, the render method should be overridden to output/present buffers.

##### Attributes

`parent_class` (Gst.ElementClass) –

Element parent class

### GstBase.BaseSinkClass

Subclasses can override any of the available virtual methods or not, as needed. At the minimum, the render method should be overridden to output/present buffers.

##### Attributes

`parent_class` (Gst.ElementClass) –

Element parent class

## GstBase.BaseSink

    GObject.Object
        ╰──GObject.InitiallyUnowned
            ╰──Gst.Object
                ╰──Gst.Element
                    ╰──GstBase.BaseSink

The opaque GstBase.BaseSink data structure.

### Members

`element` (Gst.Element) –
No description available
`sinkpad` (Gst.Pad) –
No description available
`pad_mode` (Gst.PadMode) –
No description available
`offset` (Number) –
No description available
`can_activate_pull` (Number) –
No description available
`can_activate_push` (Number) –
No description available
`preroll_lock` (GLib.Mutex) –
No description available
`preroll_cond` (GLib.Cond) –
No description available
`eos` (Number) –
No description available
`need_preroll` (Number) –
No description available
`have_preroll` (Number) –
No description available
`playing_async` (Number) –
No description available
`have_newsegment` (Number) –
No description available
`segment` (Gst.Segment) –
No description available

## GstBase.BaseSink

    GObject.Object
        ╰──GObject.InitiallyUnowned
            ╰──Gst.Object
                ╰──Gst.Element
                    ╰──GstBase.BaseSink

The opaque GstBase.BaseSink data structure.

### Members

`element` (Gst.Element) –
No description available
`sinkpad` (Gst.Pad) –
No description available
`pad_mode` (Gst.PadMode) –
No description available
`offset` (int) –
No description available
`can_activate_pull` (bool) –
No description available
`can_activate_push` (bool) –
No description available
`preroll_lock` (GLib.Mutex) –
No description available
`preroll_cond` (GLib.Cond) –
No description available
`eos` (bool) –
No description available
`need_preroll` (bool) –
No description available
`have_preroll` (bool) –
No description available
`playing_async` (bool) –
No description available
`have_newsegment` (bool) –
No description available
`segment` (Gst.Segment) –
No description available

### Methods

#### gst_base_sink_do_preroll

    GstFlowReturn
    gst_base_sink_do_preroll (GstBaseSink * sink,
                              GstMiniObject * obj)

If the sink spawns its own thread for pulling buffers from upstream it should call this method after it has pulled a buffer. If the element needed to preroll, this function will perform the preroll and will then block until the element state is changed.

This function should be called with the PREROLL_LOCK held.

Parameters:

`sink` –

the sink

`obj` ( [transfer: none]) –

the mini object that caused the preroll

Returns –

GST_FLOW_OK if the preroll completed and processing can continue. Any other return value should be returned from the render vmethod.

#### GstBase.BaseSink.prototype.do_preroll

    function GstBase.BaseSink.prototype.do_preroll(obj: Gst.MiniObject): {
        // javascript wrapper for 'gst_base_sink_do_preroll'
    }

If the sink spawns its own thread for pulling buffers from upstream it should call this method after it has pulled a buffer. If the element needed to preroll, this function will perform the preroll and will then block until the element state is changed.

This function should be called with the PREROLL_LOCK held.

Parameters:

`sink` (GstBase.BaseSink) –

the sink

`obj` (Gst.MiniObject) –

the mini object that caused the preroll

Returns (Gst.FlowReturn) –

Gst.FlowReturn.OK if the preroll completed and processing can continue. Any other return value should be returned from the render vmethod.

#### GstBase.BaseSink.do_preroll

    def GstBase.BaseSink.do_preroll (self, obj):
        #python wrapper for 'gst_base_sink_do_preroll'

If the sink spawns its own thread for pulling buffers from upstream it should call this method after it has pulled a buffer. If the element needed to preroll, this function will perform the preroll and will then block until the element state is changed.

This function should be called with the PREROLL_LOCK held.

Parameters:

`sink` (GstBase.BaseSink) –

the sink

`obj` (Gst.MiniObject) –

the mini object that caused the preroll

Returns (Gst.FlowReturn) –

Gst.FlowReturn.OK if the preroll completed and processing can continue. Any other return value should be returned from the render vmethod.

#### gst_base_sink_get_blocksize

    guint
    gst_base_sink_get_blocksize (GstBaseSink * sink)

Get the number of bytes that the sink will pull when it is operating in pull mode.

Parameters:

`sink` –

a GstBaseSink

Returns –

the number of bytes sink will pull in pull mode.

#### GstBase.BaseSink.prototype.get_blocksize

    function GstBase.BaseSink.prototype.get_blocksize(): {
        // javascript wrapper for 'gst_base_sink_get_blocksize'
    }

Get the number of bytes that the sink will pull when it is operating in pull mode.

Parameters:

`sink` (GstBase.BaseSink) –

a GstBase.BaseSink

Returns (Number) –

the number of bytes sink will pull in pull mode.

#### GstBase.BaseSink.get_blocksize

    def GstBase.BaseSink.get_blocksize (self):
        #python wrapper for 'gst_base_sink_get_blocksize'

Get the number of bytes that the sink will pull when it is operating in pull mode.

Parameters:

`sink` (GstBase.BaseSink) –

a GstBase.BaseSink

Returns (int) –

the number of bytes sink will pull in pull mode.

#### gst_base_sink_get_drop_out_of_segment

    gboolean
    gst_base_sink_get_drop_out_of_segment (GstBaseSink * sink)

Checks if sink is currently configured to drop buffers which are outside the current segment

Parameters:

`sink` –

the sink

Returns –

TRUE if the sink is configured to drop buffers outside the current segment.

Since : 1.12

#### GstBase.BaseSink.prototype.get_drop_out_of_segment

    function GstBase.BaseSink.prototype.get_drop_out_of_segment(): {
        // javascript wrapper for 'gst_base_sink_get_drop_out_of_segment'
    }

Checks if sink is currently configured to drop buffers which are outside the current segment

Parameters:

`sink` (GstBase.BaseSink) –

the sink

Returns (Number) –

true if the sink is configured to drop buffers outside the current segment.

Since : 1.12

#### GstBase.BaseSink.get_drop_out_of_segment

    def GstBase.BaseSink.get_drop_out_of_segment (self):
        #python wrapper for 'gst_base_sink_get_drop_out_of_segment'

Checks if sink is currently configured to drop buffers which are outside the current segment

Parameters:

`sink` (GstBase.BaseSink) –

the sink

Returns (bool) –

True if the sink is configured to drop buffers outside the current segment.

Since : 1.12

#### gst_base_sink_get_last_sample

    GstSample *
    gst_base_sink_get_last_sample (GstBaseSink * sink)

Get the last sample that arrived in the sink and was used for preroll or for rendering. This property can be used to generate thumbnails.

The GstCaps on the sample can be used to determine the type of the buffer.

Free-function: gst_sample_unref

Parameters:

`sink` –

the sink

Returns ( [transfer: full][nullable]) –

a GstSample. gst_sample_unref after usage. This function returns NULL when no buffer has arrived in the sink yet or when the sink is not in PAUSED or PLAYING.

#### GstBase.BaseSink.prototype.get_last_sample

    function GstBase.BaseSink.prototype.get_last_sample(): {
        // javascript wrapper for 'gst_base_sink_get_last_sample'
    }

Get the last sample that arrived in the sink and was used for preroll or for rendering. This property can be used to generate thumbnails.

The Gst.Caps on the sample can be used to determine the type of the buffer.

Free-function: gst_sample_unref

Parameters:

`sink` (GstBase.BaseSink) –

the sink

Returns (Gst.Sample) –

a Gst.Sample. gst_sample_unref (not introspectable) after usage. This function returns null when no buffer has arrived in the sink yet or when the sink is not in PAUSED or PLAYING.

#### GstBase.BaseSink.get_last_sample

    def GstBase.BaseSink.get_last_sample (self):
        #python wrapper for 'gst_base_sink_get_last_sample'

Get the last sample that arrived in the sink and was used for preroll or for rendering. This property can be used to generate thumbnails.

The Gst.Caps on the sample can be used to determine the type of the buffer.

Free-function: gst_sample_unref

Parameters:

`sink` (GstBase.BaseSink) –

the sink

Returns (Gst.Sample) –

a Gst.Sample. gst_sample_unref (not introspectable) after usage. This function returns None when no buffer has arrived in the sink yet or when the sink is not in PAUSED or PLAYING.

#### gst_base_sink_get_latency

    GstClockTime
    gst_base_sink_get_latency (GstBaseSink * sink)

Get the currently configured latency.

Parameters:

`sink` –

the sink

Returns –

The configured latency.

#### GstBase.BaseSink.prototype.get_latency

    function GstBase.BaseSink.prototype.get_latency(): {
        // javascript wrapper for 'gst_base_sink_get_latency'
    }

Get the currently configured latency.

Parameters:

`sink` (GstBase.BaseSink) –

the sink

Returns (Number) –

The configured latency.

#### GstBase.BaseSink.get_latency

    def GstBase.BaseSink.get_latency (self):
        #python wrapper for 'gst_base_sink_get_latency'

Get the currently configured latency.

Parameters:

`sink` (GstBase.BaseSink) –

the sink

Returns (int) –

The configured latency.

#### gst_base_sink_get_max_bitrate

    guint64
    gst_base_sink_get_max_bitrate (GstBaseSink * sink)

Get the maximum amount of bits per second that the sink will render.

Parameters:

`sink` –

a GstBaseSink

Returns –

the maximum number of bits per second sink will render.

Since : 1.2

#### GstBase.BaseSink.prototype.get_max_bitrate

    function GstBase.BaseSink.prototype.get_max_bitrate(): {
        // javascript wrapper for 'gst_base_sink_get_max_bitrate'
    }

Get the maximum amount of bits per second that the sink will render.

Parameters:

`sink` (GstBase.BaseSink) –

a GstBase.BaseSink

Returns (Number) –

the maximum number of bits per second sink will render.

Since : 1.2

#### GstBase.BaseSink.get_max_bitrate

    def GstBase.BaseSink.get_max_bitrate (self):
        #python wrapper for 'gst_base_sink_get_max_bitrate'

Get the maximum amount of bits per second that the sink will render.

Parameters:

`sink` (GstBase.BaseSink) –

a GstBase.BaseSink

Returns (int) –

the maximum number of bits per second sink will render.

Since : 1.2

#### gst_base_sink_get_max_lateness

    gint64
    gst_base_sink_get_max_lateness (GstBaseSink * sink)

Gets the max lateness value. See gst_base_sink_set_max_lateness for more details.

Parameters:

`sink` –

the sink

Returns –

The maximum time in nanoseconds that a buffer can be late before it is dropped and not rendered. A value of -1 means an unlimited time.

#### GstBase.BaseSink.prototype.get_max_lateness

    function GstBase.BaseSink.prototype.get_max_lateness(): {
        // javascript wrapper for 'gst_base_sink_get_max_lateness'
    }

Gets the max lateness value. See GstBase.BaseSink.prototype.set_max_lateness for more details.

Parameters:

`sink` (GstBase.BaseSink) –

the sink

Returns (Number) –

The maximum time in nanoseconds that a buffer can be late before it is dropped and not rendered. A value of -1 means an unlimited time.

#### GstBase.BaseSink.get_max_lateness

    def GstBase.BaseSink.get_max_lateness (self):
        #python wrapper for 'gst_base_sink_get_max_lateness'

Gets the max lateness value. See GstBase.BaseSink.set_max_lateness for more details.

Parameters:

`sink` (GstBase.BaseSink) –

the sink

Returns (int) –

The maximum time in nanoseconds that a buffer can be late before it is dropped and not rendered. A value of -1 means an unlimited time.

#### gst_base_sink_get_processing_deadline

    GstClockTime
    gst_base_sink_get_processing_deadline (GstBaseSink * sink)

Get the processing deadline of sink. see gst_base_sink_set_processing_deadline for more information about the processing deadline.

Parameters:

`sink` –

a GstBaseSink

Returns –

the processing deadline

Since : 1.16

#### GstBase.BaseSink.prototype.get_processing_deadline

    function GstBase.BaseSink.prototype.get_processing_deadline(): {
        // javascript wrapper for 'gst_base_sink_get_processing_deadline'
    }

Get the processing deadline of sink. see GstBase.BaseSink.prototype.set_processing_deadline for more information about the processing deadline.

Parameters:

`sink` (GstBase.BaseSink) –

a GstBase.BaseSink

Returns (Number) –

the processing deadline

Since : 1.16

#### GstBase.BaseSink.get_processing_deadline

    def GstBase.BaseSink.get_processing_deadline (self):
        #python wrapper for 'gst_base_sink_get_processing_deadline'

Get the processing deadline of sink. see GstBase.BaseSink.set_processing_deadline for more information about the processing deadline.

Parameters:

`sink` (GstBase.BaseSink) –

a GstBase.BaseSink

Returns (int) –

the processing deadline

Since : 1.16

#### gst_base_sink_get_render_delay

    GstClockTime
    gst_base_sink_get_render_delay (GstBaseSink * sink)

Get the render delay of sink. see gst_base_sink_set_render_delay for more information about the render delay.

Parameters:

`sink` –

a GstBaseSink

Returns –

the render delay of sink.

#### GstBase.BaseSink.prototype.get_render_delay

    function GstBase.BaseSink.prototype.get_render_delay(): {
        // javascript wrapper for 'gst_base_sink_get_render_delay'
    }

Get the render delay of sink. see GstBase.BaseSink.prototype.set_render_delay for more information about the render delay.

Parameters:

`sink` (GstBase.BaseSink) –

a GstBase.BaseSink

Returns (Number) –

the render delay of sink.

#### GstBase.BaseSink.get_render_delay

    def GstBase.BaseSink.get_render_delay (self):
        #python wrapper for 'gst_base_sink_get_render_delay'

Get the render delay of sink. see GstBase.BaseSink.set_render_delay for more information about the render delay.

Parameters:

`sink` (GstBase.BaseSink) –

a GstBase.BaseSink

Returns (int) –

the render delay of sink.

#### gst_base_sink_get_stats

    GstStructure *
    gst_base_sink_get_stats (GstBaseSink * sink)

Return various GstBaseSink statistics. This function returns a GstStructure with name `application/x-gst-base-sink-stats` with the following fields:

- "average-rate" G_TYPE_DOUBLE average frame rate
- "dropped" G_TYPE_UINT64 Number of dropped frames
- "rendered" G_TYPE_UINT64 Number of rendered frames

Parameters:

`sink` –

GstBaseSink

Returns ( [transfer: full]) –

pointer to GstStructure

Since : 1.18

#### GstBase.BaseSink.prototype.get_stats

    function GstBase.BaseSink.prototype.get_stats(): {
        // javascript wrapper for 'gst_base_sink_get_stats'
    }

Return various GstBase.BaseSink statistics. This function returns a Gst.Structure with name `application/x-gst-base-sink-stats` with the following fields:

- "average-rate" G_TYPE_DOUBLE average frame rate
- "dropped" G_TYPE_UINT64 Number of dropped frames
- "rendered" G_TYPE_UINT64 Number of rendered frames

Parameters:

`sink` (GstBase.BaseSink) –

GstBase.BaseSink

Returns (Gst.Structure) –

pointer to Gst.Structure

Since : 1.18

#### GstBase.BaseSink.get_stats

    def GstBase.BaseSink.get_stats (self):
        #python wrapper for 'gst_base_sink_get_stats'

Return various GstBase.BaseSink statistics. This function returns a Gst.Structure with name `application/x-gst-base-sink-stats` with the following fields:

- "average-rate" G_TYPE_DOUBLE average frame rate
- "dropped" G_TYPE_UINT64 Number of dropped frames
- "rendered" G_TYPE_UINT64 Number of rendered frames

Parameters:

`sink` (GstBase.BaseSink) –

GstBase.BaseSink

Returns (Gst.Structure) –

pointer to Gst.Structure

Since : 1.18

#### gst_base_sink_get_sync

    gboolean
    gst_base_sink_get_sync (GstBaseSink * sink)

Checks if sink is currently configured to synchronize against the clock.

Parameters:

`sink` –

the sink

Returns –

TRUE if the sink is configured to synchronize against the clock.

#### GstBase.BaseSink.prototype.get_sync

    function GstBase.BaseSink.prototype.get_sync(): {
        // javascript wrapper for 'gst_base_sink_get_sync'
    }

Checks if sink is currently configured to synchronize against the clock.

Parameters:

`sink` (GstBase.BaseSink) –

the sink

Returns (Number) –

true if the sink is configured to synchronize against the clock.

#### GstBase.BaseSink.get_sync

    def GstBase.BaseSink.get_sync (self):
        #python wrapper for 'gst_base_sink_get_sync'

Checks if sink is currently configured to synchronize against the clock.

Parameters:

`sink` (GstBase.BaseSink) –

the sink

Returns (bool) –

True if the sink is configured to synchronize against the clock.

#### gst_base_sink_get_throttle_time

    guint64
    gst_base_sink_get_throttle_time (GstBaseSink * sink)

Get the time that will be inserted between frames to control the maximum buffers per second.

Parameters:

`sink` –

a GstBaseSink

Returns –

the number of nanoseconds sink will put between frames.

#### GstBase.BaseSink.prototype.get_throttle_time

    function GstBase.BaseSink.prototype.get_throttle_time(): {
        // javascript wrapper for 'gst_base_sink_get_throttle_time'
    }

Get the time that will be inserted between frames to control the maximum buffers per second.

Parameters:

`sink` (GstBase.BaseSink) –

a GstBase.BaseSink

Returns (Number) –

the number of nanoseconds sink will put between frames.

#### GstBase.BaseSink.get_throttle_time

    def GstBase.BaseSink.get_throttle_time (self):
        #python wrapper for 'gst_base_sink_get_throttle_time'

Get the time that will be inserted between frames to control the maximum buffers per second.

Parameters:

`sink` (GstBase.BaseSink) –

a GstBase.BaseSink

Returns (int) –

the number of nanoseconds sink will put between frames.

#### gst_base_sink_get_ts_offset

    GstClockTimeDiff
    gst_base_sink_get_ts_offset (GstBaseSink * sink)

Get the synchronisation offset of sink.

Parameters:

`sink` –

the sink

Returns –

The synchronisation offset.

#### GstBase.BaseSink.prototype.get_ts_offset

    function GstBase.BaseSink.prototype.get_ts_offset(): {
        // javascript wrapper for 'gst_base_sink_get_ts_offset'
    }

Get the synchronisation offset of sink.

Parameters:

`sink` (GstBase.BaseSink) –

the sink

Returns (Number) –

The synchronisation offset.

#### GstBase.BaseSink.get_ts_offset

    def GstBase.BaseSink.get_ts_offset (self):
        #python wrapper for 'gst_base_sink_get_ts_offset'

Get the synchronisation offset of sink.

Parameters:

`sink` (GstBase.BaseSink) –

the sink

Returns (int) –

The synchronisation offset.

#### gst_base_sink_is_async_enabled

    gboolean
    gst_base_sink_is_async_enabled (GstBaseSink * sink)

Checks if sink is currently configured to perform asynchronous state changes to PAUSED.

Parameters:

`sink` –

the sink

Returns –

TRUE if the sink is configured to perform asynchronous state changes.

#### GstBase.BaseSink.prototype.is_async_enabled

    function GstBase.BaseSink.prototype.is_async_enabled(): {
        // javascript wrapper for 'gst_base_sink_is_async_enabled'
    }

Checks if sink is currently configured to perform asynchronous state changes to PAUSED.

Parameters:

`sink` (GstBase.BaseSink) –

the sink

Returns (Number) –

true if the sink is configured to perform asynchronous state changes.

#### GstBase.BaseSink.is_async_enabled

    def GstBase.BaseSink.is_async_enabled (self):
        #python wrapper for 'gst_base_sink_is_async_enabled'

Checks if sink is currently configured to perform asynchronous state changes to PAUSED.

Parameters:

`sink` (GstBase.BaseSink) –

the sink

Returns (bool) –

True if the sink is configured to perform asynchronous state changes.

#### gst_base_sink_is_last_sample_enabled

    gboolean
    gst_base_sink_is_last_sample_enabled (GstBaseSink * sink)

Checks if sink is currently configured to store the last received sample in the last-sample property.

Parameters:

`sink` –

the sink

Returns –

TRUE if the sink is configured to store the last received sample.

#### GstBase.BaseSink.prototype.is_last_sample_enabled

    function GstBase.BaseSink.prototype.is_last_sample_enabled(): {
        // javascript wrapper for 'gst_base_sink_is_last_sample_enabled'
    }

Checks if sink is currently configured to store the last received sample in the last-sample property.

Parameters:

`sink` (GstBase.BaseSink) –

the sink

Returns (Number) –

true if the sink is configured to store the last received sample.

#### GstBase.BaseSink.is_last_sample_enabled

    def GstBase.BaseSink.is_last_sample_enabled (self):
        #python wrapper for 'gst_base_sink_is_last_sample_enabled'

Checks if sink is currently configured to store the last received sample in the last-sample property.

Parameters:

`sink` (GstBase.BaseSink) –

the sink

Returns (bool) –

True if the sink is configured to store the last received sample.

#### gst_base_sink_is_qos_enabled

    gboolean
    gst_base_sink_is_qos_enabled (GstBaseSink * sink)

Checks if sink is currently configured to send Quality-of-Service events upstream.

Parameters:

`sink` –

the sink

Returns –

TRUE if the sink is configured to perform Quality-of-Service.

#### GstBase.BaseSink.prototype.is_qos_enabled

    function GstBase.BaseSink.prototype.is_qos_enabled(): {
        // javascript wrapper for 'gst_base_sink_is_qos_enabled'
    }

Checks if sink is currently configured to send Quality-of-Service events upstream.

Parameters:

`sink` (GstBase.BaseSink) –

the sink

Returns (Number) –

true if the sink is configured to perform Quality-of-Service.

#### GstBase.BaseSink.is_qos_enabled

    def GstBase.BaseSink.is_qos_enabled (self):
        #python wrapper for 'gst_base_sink_is_qos_enabled'

Checks if sink is currently configured to send Quality-of-Service events upstream.

Parameters:

`sink` (GstBase.BaseSink) –

the sink

Returns (bool) –

True if the sink is configured to perform Quality-of-Service.

#### gst_base_sink_query_latency

    gboolean
    gst_base_sink_query_latency (GstBaseSink * sink,
                                 gboolean * live,
                                 gboolean * upstream_live,
                                 GstClockTime * min_latency,
                                 GstClockTime * max_latency)

Query the sink for the latency parameters. The latency will be queried from the upstream elements. live will be TRUE if sink is configured to synchronize against the clock. upstream_live will be TRUE if an upstream element is live.

If both live and upstream_live are TRUE, the sink will want to compensate for the latency introduced by the upstream elements by setting the min_latency to a strictly positive value.

This function is mostly used by subclasses.

Parameters:

`sink` –

the sink

`live` ( [out][allow-none]) –

if the sink is live

`upstream_live` ( [out][allow-none]) –

if an upstream element is live

`min_latency` ( [out][allow-none]) –

the min latency of the upstream elements

`max_latency` ( [out][allow-none]) –

the max latency of the upstream elements

Returns –

TRUE if the query succeeded.

#### GstBase.BaseSink.prototype.query_latency

    function GstBase.BaseSink.prototype.query_latency(): {
        // javascript wrapper for 'gst_base_sink_query_latency'
    }

Query the sink for the latency parameters. The latency will be queried from the upstream elements. live will be true if sink is configured to synchronize against the clock. upstream_live will be true if an upstream element is live.

If both live and upstream_live are true, the sink will want to compensate for the latency introduced by the upstream elements by setting the min_latency to a strictly positive value.

This function is mostly used by subclasses.

Parameters:

`sink` (GstBase.BaseSink) –

the sink

Returns a tuple made of:

(Number ) –

true if the query succeeded.

`live` (Number ) –

true if the query succeeded.

`upstream_live` (Number ) –

true if the query succeeded.

`min_latency` (Number ) –

true if the query succeeded.

`max_latency` (Number ) –

true if the query succeeded.

#### GstBase.BaseSink.query_latency

    def GstBase.BaseSink.query_latency (self):
        #python wrapper for 'gst_base_sink_query_latency'

Query the sink for the latency parameters. The latency will be queried from the upstream elements. live will be True if sink is configured to synchronize against the clock. upstream_live will be True if an upstream element is live.

If both live and upstream_live are True, the sink will want to compensate for the latency introduced by the upstream elements by setting the min_latency to a strictly positive value.

This function is mostly used by subclasses.

Parameters:

`sink` (GstBase.BaseSink) –

the sink

Returns a tuple made of:

(bool ) –

True if the query succeeded.

`live` (bool ) –

True if the query succeeded.

`upstream_live` (bool ) –

True if the query succeeded.

`min_latency` (int ) –

True if the query succeeded.

`max_latency` (int ) –

True if the query succeeded.

#### gst_base_sink_set_async_enabled

    gst_base_sink_set_async_enabled (GstBaseSink * sink,
                                     gboolean enabled)

Configures sink to perform all state changes asynchronously. When async is disabled, the sink will immediately go to PAUSED instead of waiting for a preroll buffer. This feature is useful if the sink does not synchronize against the clock or when it is dealing with sparse streams.

Parameters:

`sink` –

the sink

`enabled` –

the new async value.

#### GstBase.BaseSink.prototype.set_async_enabled

    function GstBase.BaseSink.prototype.set_async_enabled(enabled: Number): {
        // javascript wrapper for 'gst_base_sink_set_async_enabled'
    }

Configures sink to perform all state changes asynchronously. When async is disabled, the sink will immediately go to PAUSED instead of waiting for a preroll buffer. This feature is useful if the sink does not synchronize against the clock or when it is dealing with sparse streams.

Parameters:

`sink` (GstBase.BaseSink) –

the sink

`enabled` (Number) –

the new async value.

#### GstBase.BaseSink.set_async_enabled

    def GstBase.BaseSink.set_async_enabled (self, enabled):
        #python wrapper for 'gst_base_sink_set_async_enabled'

Configures sink to perform all state changes asynchronously. When async is disabled, the sink will immediately go to PAUSED instead of waiting for a preroll buffer. This feature is useful if the sink does not synchronize against the clock or when it is dealing with sparse streams.

Parameters:

`sink` (GstBase.BaseSink) –

the sink

`enabled` (bool) –

the new async value.

#### gst_base_sink_set_blocksize

    gst_base_sink_set_blocksize (GstBaseSink * sink,
                                 guint blocksize)

Set the number of bytes that the sink will pull when it is operating in pull mode.

Parameters:

`sink` –

a GstBaseSink

`blocksize` –

the blocksize in bytes

#### GstBase.BaseSink.prototype.set_blocksize

    function GstBase.BaseSink.prototype.set_blocksize(blocksize: Number): {
        // javascript wrapper for 'gst_base_sink_set_blocksize'
    }

Set the number of bytes that the sink will pull when it is operating in pull mode.

Parameters:

`sink` (GstBase.BaseSink) –

a GstBase.BaseSink

`blocksize` (Number) –

the blocksize in bytes

#### GstBase.BaseSink.set_blocksize

    def GstBase.BaseSink.set_blocksize (self, blocksize):
        #python wrapper for 'gst_base_sink_set_blocksize'

Set the number of bytes that the sink will pull when it is operating in pull mode.

Parameters:

`sink` (GstBase.BaseSink) –

a GstBase.BaseSink

`blocksize` (int) –

the blocksize in bytes

#### gst_base_sink_set_drop_out_of_segment

    gst_base_sink_set_drop_out_of_segment (GstBaseSink * sink,
                                           gboolean drop_out_of_segment)

Configure sink to drop buffers which are outside the current segment

Parameters:

`sink` –

the sink

`drop_out_of_segment` –

drop buffers outside the segment

Since : 1.12

#### GstBase.BaseSink.prototype.set_drop_out_of_segment

    function GstBase.BaseSink.prototype.set_drop_out_of_segment(drop_out_of_segment: Number): {
        // javascript wrapper for 'gst_base_sink_set_drop_out_of_segment'
    }

Configure sink to drop buffers which are outside the current segment

Parameters:

`sink` (GstBase.BaseSink) –

the sink

`drop_out_of_segment` (Number) –

drop buffers outside the segment

Since : 1.12

#### GstBase.BaseSink.set_drop_out_of_segment

    def GstBase.BaseSink.set_drop_out_of_segment (self, drop_out_of_segment):
        #python wrapper for 'gst_base_sink_set_drop_out_of_segment'

Configure sink to drop buffers which are outside the current segment

Parameters:

`sink` (GstBase.BaseSink) –

the sink

`drop_out_of_segment` (bool) –

drop buffers outside the segment

Since : 1.12

#### gst_base_sink_set_last_sample_enabled

    gst_base_sink_set_last_sample_enabled (GstBaseSink * sink,
                                           gboolean enabled)

Configures sink to store the last received sample in the last-sample property.

Parameters:

`sink` –

the sink

`enabled` –

the new enable-last-sample value.

#### GstBase.BaseSink.prototype.set_last_sample_enabled

    function GstBase.BaseSink.prototype.set_last_sample_enabled(enabled: Number): {
        // javascript wrapper for 'gst_base_sink_set_last_sample_enabled'
    }

Configures sink to store the last received sample in the last-sample property.

Parameters:

`sink` (GstBase.BaseSink) –

the sink

`enabled` (Number) –

the new enable-last-sample value.

#### GstBase.BaseSink.set_last_sample_enabled

    def GstBase.BaseSink.set_last_sample_enabled (self, enabled):
        #python wrapper for 'gst_base_sink_set_last_sample_enabled'

Configures sink to store the last received sample in the last-sample property.

Parameters:

`sink` (GstBase.BaseSink) –

the sink

`enabled` (bool) –

the new enable-last-sample value.

#### gst_base_sink_set_max_bitrate

    gst_base_sink_set_max_bitrate (GstBaseSink * sink,
                                   guint64 max_bitrate)

Set the maximum amount of bits per second that the sink will render.

Parameters:

`sink` –

a GstBaseSink

`max_bitrate` –

the max_bitrate in bits per second

Since : 1.2

#### GstBase.BaseSink.prototype.set_max_bitrate

    function GstBase.BaseSink.prototype.set_max_bitrate(max_bitrate: Number): {
        // javascript wrapper for 'gst_base_sink_set_max_bitrate'
    }

Set the maximum amount of bits per second that the sink will render.

Parameters:

`sink` (GstBase.BaseSink) –

a GstBase.BaseSink

`max_bitrate` (Number) –

the max_bitrate in bits per second

Since : 1.2

#### GstBase.BaseSink.set_max_bitrate

    def GstBase.BaseSink.set_max_bitrate (self, max_bitrate):
        #python wrapper for 'gst_base_sink_set_max_bitrate'

Set the maximum amount of bits per second that the sink will render.

Parameters:

`sink` (GstBase.BaseSink) –

a GstBase.BaseSink

`max_bitrate` (int) –

the max_bitrate in bits per second

Since : 1.2

#### gst_base_sink_set_max_lateness

    gst_base_sink_set_max_lateness (GstBaseSink * sink,
                                    gint64 max_lateness)

Sets the new max lateness value to max_lateness. This value is used to decide if a buffer should be dropped or not based on the buffer timestamp and the current clock time. A value of -1 means an unlimited time.

Parameters:

`sink` –

the sink

`max_lateness` –

the new max lateness value.

#### GstBase.BaseSink.prototype.set_max_lateness

    function GstBase.BaseSink.prototype.set_max_lateness(max_lateness: Number): {
        // javascript wrapper for 'gst_base_sink_set_max_lateness'
    }

Sets the new max lateness value to max_lateness. This value is used to decide if a buffer should be dropped or not based on the buffer timestamp and the current clock time. A value of -1 means an unlimited time.

Parameters:

`sink` (GstBase.BaseSink) –

the sink

`max_lateness` (Number) –

the new max lateness value.

#### GstBase.BaseSink.set_max_lateness

    def GstBase.BaseSink.set_max_lateness (self, max_lateness):
        #python wrapper for 'gst_base_sink_set_max_lateness'

Sets the new max lateness value to max_lateness. This value is used to decide if a buffer should be dropped or not based on the buffer timestamp and the current clock time. A value of -1 means an unlimited time.

Parameters:

`sink` (GstBase.BaseSink) –

the sink

`max_lateness` (int) –

the new max lateness value.

#### gst_base_sink_set_processing_deadline

    gst_base_sink_set_processing_deadline (GstBaseSink * sink,
                                           GstClockTime processing_deadline)

Maximum amount of time (in nanoseconds) that the pipeline can take for processing the buffer. This is added to the latency of live pipelines.

This function is usually called by subclasses.

Parameters:

`sink` –

a GstBaseSink

`processing_deadline` –

the new processing deadline in nanoseconds.

Since : 1.16

#### GstBase.BaseSink.prototype.set_processing_deadline

    function GstBase.BaseSink.prototype.set_processing_deadline(processing_deadline: Number): {
        // javascript wrapper for 'gst_base_sink_set_processing_deadline'
    }

Maximum amount of time (in nanoseconds) that the pipeline can take for processing the buffer. This is added to the latency of live pipelines.

This function is usually called by subclasses.

Parameters:

`sink` (GstBase.BaseSink) –

a GstBase.BaseSink

`processing_deadline` (Number) –

the new processing deadline in nanoseconds.

Since : 1.16

#### GstBase.BaseSink.set_processing_deadline

    def GstBase.BaseSink.set_processing_deadline (self, processing_deadline):
        #python wrapper for 'gst_base_sink_set_processing_deadline'

Maximum amount of time (in nanoseconds) that the pipeline can take for processing the buffer. This is added to the latency of live pipelines.

This function is usually called by subclasses.

Parameters:

`sink` (GstBase.BaseSink) –

a GstBase.BaseSink

`processing_deadline` (int) –

the new processing deadline in nanoseconds.

Since : 1.16

#### gst_base_sink_set_qos_enabled

    gst_base_sink_set_qos_enabled (GstBaseSink * sink,
                                   gboolean enabled)

Configures sink to send Quality-of-Service events upstream.

Parameters:

`sink` –

the sink

`enabled` –

the new qos value.

#### GstBase.BaseSink.prototype.set_qos_enabled

    function GstBase.BaseSink.prototype.set_qos_enabled(enabled: Number): {
        // javascript wrapper for 'gst_base_sink_set_qos_enabled'
    }

Configures sink to send Quality-of-Service events upstream.

Parameters:

`sink` (GstBase.BaseSink) –

the sink

`enabled` (Number) –

the new qos value.

#### GstBase.BaseSink.set_qos_enabled

    def GstBase.BaseSink.set_qos_enabled (self, enabled):
        #python wrapper for 'gst_base_sink_set_qos_enabled'

Configures sink to send Quality-of-Service events upstream.

Parameters:

`sink` (GstBase.BaseSink) –

the sink

`enabled` (bool) –

the new qos value.

#### gst_base_sink_set_render_delay

    gst_base_sink_set_render_delay (GstBaseSink * sink,
                                    GstClockTime delay)

Set the render delay in sink to delay. The render delay is the time between actual rendering of a buffer and its synchronisation time. Some devices might delay media rendering which can be compensated for with this function.

After calling this function, this sink will report additional latency and other sinks will adjust their latency to delay the rendering of their media.

This function is usually called by subclasses.

Parameters:

`sink` –

a GstBaseSink

`delay` –

the new delay

#### GstBase.BaseSink.prototype.set_render_delay

    function GstBase.BaseSink.prototype.set_render_delay(delay: Number): {
        // javascript wrapper for 'gst_base_sink_set_render_delay'
    }

Set the render delay in sink to delay. The render delay is the time between actual rendering of a buffer and its synchronisation time. Some devices might delay media rendering which can be compensated for with this function.

After calling this function, this sink will report additional latency and other sinks will adjust their latency to delay the rendering of their media.

This function is usually called by subclasses.

Parameters:

`sink` (GstBase.BaseSink) –

a GstBase.BaseSink

`delay` (Number) –

the new delay

#### GstBase.BaseSink.set_render_delay

    def GstBase.BaseSink.set_render_delay (self, delay):
        #python wrapper for 'gst_base_sink_set_render_delay'

Set the render delay in sink to delay. The render delay is the time between actual rendering of a buffer and its synchronisation time. Some devices might delay media rendering which can be compensated for with this function.

After calling this function, this sink will report additional latency and other sinks will adjust their latency to delay the rendering of their media.

This function is usually called by subclasses.

Parameters:

`sink` (GstBase.BaseSink) –

a GstBase.BaseSink

`delay` (int) –

the new delay

#### gst_base_sink_set_sync

    gst_base_sink_set_sync (GstBaseSink * sink,
                            gboolean sync)

Configures sink to synchronize on the clock or not. When sync is FALSE, incoming samples will be played as fast as possible. If sync is TRUE, the timestamps of the incoming buffers will be used to schedule the exact render time of its contents.

Parameters:

`sink` –

the sink

`sync` –

the new sync value.

#### GstBase.BaseSink.prototype.set_sync

    function GstBase.BaseSink.prototype.set_sync(sync: Number): {
        // javascript wrapper for 'gst_base_sink_set_sync'
    }

Configures sink to synchronize on the clock or not. When sync is false, incoming samples will be played as fast as possible. If sync is true, the timestamps of the incoming buffers will be used to schedule the exact render time of its contents.

Parameters:

`sink` (GstBase.BaseSink) –

the sink

`sync` (Number) –

the new sync value.

#### GstBase.BaseSink.set_sync

    def GstBase.BaseSink.set_sync (self, sync):
        #python wrapper for 'gst_base_sink_set_sync'

Configures sink to synchronize on the clock or not. When sync is False, incoming samples will be played as fast as possible. If sync is True, the timestamps of the incoming buffers will be used to schedule the exact render time of its contents.

Parameters:

`sink` (GstBase.BaseSink) –

the sink

`sync` (bool) –

the new sync value.

#### gst_base_sink_set_throttle_time

    gst_base_sink_set_throttle_time (GstBaseSink * sink,
                                     guint64 throttle)

Set the time that will be inserted between rendered buffers. This can be used to control the maximum buffers per second that the sink will render.

Parameters:

`sink` –

a GstBaseSink

`throttle` –

the throttle time in nanoseconds

#### GstBase.BaseSink.prototype.set_throttle_time

    function GstBase.BaseSink.prototype.set_throttle_time(throttle: Number): {
        // javascript wrapper for 'gst_base_sink_set_throttle_time'
    }

Set the time that will be inserted between rendered buffers. This can be used to control the maximum buffers per second that the sink will render.

Parameters:

`sink` (GstBase.BaseSink) –

a GstBase.BaseSink

`throttle` (Number) –

the throttle time in nanoseconds

#### GstBase.BaseSink.set_throttle_time

    def GstBase.BaseSink.set_throttle_time (self, throttle):
        #python wrapper for 'gst_base_sink_set_throttle_time'

Set the time that will be inserted between rendered buffers. This can be used to control the maximum buffers per second that the sink will render.

Parameters:

`sink` (GstBase.BaseSink) –

a GstBase.BaseSink

`throttle` (int) –

the throttle time in nanoseconds

#### gst_base_sink_set_ts_offset

    gst_base_sink_set_ts_offset (GstBaseSink * sink,
                                 GstClockTimeDiff offset)

Adjust the synchronisation of sink with offset. A negative value will render buffers earlier than their timestamp. A positive value will delay rendering. This function can be used to fix playback of badly timestamped buffers.

Parameters:

`sink` –

the sink

`offset` –

the new offset

#### GstBase.BaseSink.prototype.set_ts_offset

    function GstBase.BaseSink.prototype.set_ts_offset(offset: Number): {
        // javascript wrapper for 'gst_base_sink_set_ts_offset'
    }

Adjust the synchronisation of sink with offset. A negative value will render buffers earlier than their timestamp. A positive value will delay rendering. This function can be used to fix playback of badly timestamped buffers.

Parameters:

`sink` (GstBase.BaseSink) –

the sink

`offset` (Number) –

the new offset

#### GstBase.BaseSink.set_ts_offset

    def GstBase.BaseSink.set_ts_offset (self, offset):
        #python wrapper for 'gst_base_sink_set_ts_offset'

Adjust the synchronisation of sink with offset. A negative value will render buffers earlier than their timestamp. A positive value will delay rendering. This function can be used to fix playback of badly timestamped buffers.

Parameters:

`sink` (GstBase.BaseSink) –

the sink

`offset` (int) –

the new offset

#### gst_base_sink_wait

    GstFlowReturn
    gst_base_sink_wait (GstBaseSink * sink,
                        GstClockTime time,
                        GstClockTimeDiff * jitter)

This function will wait for preroll to complete and will then block until time is reached. It is usually called by subclasses that use their own internal synchronisation but want to let some synchronization (like EOS) be handled by the base class.

This function should only be called with the PREROLL_LOCK held (like when receiving an EOS event in the ::event vmethod or when handling buffers in ::render).

The time argument should be the running_time of when the timeout should happen and will be adjusted with any latency and offset configured in the sink.

Parameters:

`sink` –

the sink

`time` –

the running_time to be reached

`jitter` ( [out][allow-none]) –

the jitter to be filled with time diff, or NULL

Returns –

GstFlowReturn

#### GstBase.BaseSink.prototype.wait

    function GstBase.BaseSink.prototype.wait(time: Number): {
        // javascript wrapper for 'gst_base_sink_wait'
    }

This function will wait for preroll to complete and will then block until time is reached. It is usually called by subclasses that use their own internal synchronisation but want to let some synchronization (like EOS) be handled by the base class.

This function should only be called with the PREROLL_LOCK held (like when receiving an EOS event in the ::event vmethod or when handling buffers in ::render).

The time argument should be the running_time of when the timeout should happen and will be adjusted with any latency and offset configured in the sink.

Parameters:

`sink` (GstBase.BaseSink) –

the sink

`time` (Number) –

the running_time to be reached

Returns a tuple made of:

(Gst.FlowReturn ) –

Gst.FlowReturn

`jitter` (Number ) –

Gst.FlowReturn

#### GstBase.BaseSink.wait

    def GstBase.BaseSink.wait (self, time):
        #python wrapper for 'gst_base_sink_wait'

This function will wait for preroll to complete and will then block until time is reached. It is usually called by subclasses that use their own internal synchronisation but want to let some synchronization (like EOS) be handled by the base class.

This function should only be called with the PREROLL_LOCK held (like when receiving an EOS event in the ::event vmethod or when handling buffers in ::render).

The time argument should be the running_time of when the timeout should happen and will be adjusted with any latency and offset configured in the sink.

Parameters:

`sink` (GstBase.BaseSink) –

the sink

`time` (int) –

the running_time to be reached

Returns a tuple made of:

(Gst.FlowReturn ) –

Gst.FlowReturn

`jitter` (int ) –

Gst.FlowReturn

#### gst_base_sink_wait_clock

    GstClockReturn
    gst_base_sink_wait_clock (GstBaseSink * sink,
                              GstClockTime time,
                              GstClockTimeDiff * jitter)

This function will block until time is reached. It is usually called by subclasses that use their own internal synchronisation.

If time is not valid, no synchronisation is done and GST_CLOCK_BADTIME is returned. Likewise, if synchronisation is disabled in the element or there is no clock, no synchronisation is done and GST_CLOCK_BADTIME is returned.

This function should only be called with the PREROLL_LOCK held, like when receiving an EOS event in the event vmethod or when receiving a buffer in the render vmethod.

The time argument should be the running_time of when this method should return and is not adjusted with any latency or offset configured in the sink.

Parameters:

`sink` –

the sink

`time` –

the running_time to be reached

`jitter` ( [out][allow-none]) –

the jitter to be filled with time diff, or NULL

Returns –

GstClockReturn

#### GstBase.BaseSink.prototype.wait_clock

    function GstBase.BaseSink.prototype.wait_clock(time: Number): {
        // javascript wrapper for 'gst_base_sink_wait_clock'
    }

This function will block until time is reached. It is usually called by subclasses that use their own internal synchronisation.

If time is not valid, no synchronisation is done and Gst.ClockReturn.BADTIME is returned. Likewise, if synchronisation is disabled in the element or there is no clock, no synchronisation is done and Gst.ClockReturn.BADTIME is returned.

This function should only be called with the PREROLL_LOCK held, like when receiving an EOS event in the vfunc_event vmethod or when receiving a buffer in the vfunc_render vmethod.

The time argument should be the running_time of when this method should return and is not adjusted with any latency or offset configured in the sink.

Parameters:

`sink` (GstBase.BaseSink) –

the sink

`time` (Number) –

the running_time to be reached

Returns a tuple made of:

(Gst.ClockReturn ) –

Gst.ClockReturn

`jitter` (Number ) –

Gst.ClockReturn

#### GstBase.BaseSink.wait_clock

    def GstBase.BaseSink.wait_clock (self, time):
        #python wrapper for 'gst_base_sink_wait_clock'

This function will block until time is reached. It is usually called by subclasses that use their own internal synchronisation.

If time is not valid, no synchronisation is done and Gst.ClockReturn.BADTIME is returned. Likewise, if synchronisation is disabled in the element or there is no clock, no synchronisation is done and Gst.ClockReturn.BADTIME is returned.

This function should only be called with the PREROLL_LOCK held, like when receiving an EOS event in the do_event vmethod or when receiving a buffer in the do_render vmethod.

The time argument should be the running_time of when this method should return and is not adjusted with any latency or offset configured in the sink.

Parameters:

`sink` (GstBase.BaseSink) –

the sink

`time` (int) –

the running_time to be reached

Returns a tuple made of:

(Gst.ClockReturn ) –

Gst.ClockReturn

`jitter` (int ) –

Gst.ClockReturn

#### gst_base_sink_wait_preroll

    GstFlowReturn
    gst_base_sink_wait_preroll (GstBaseSink * sink)

If the render method performs its own synchronisation against the clock it must unblock when going from PLAYING to the PAUSED state and call this method before continuing to render the remaining data.

If the render method can block on something else than the clock, it must also be ready to unblock immediately on the unlock method and cause the render method to immediately call this function. In this case, the subclass must be prepared to continue rendering where it left off if this function returns GST_FLOW_OK.

This function will block until a state change to PLAYING happens (in which case this function returns GST_FLOW_OK) or the processing must be stopped due to a state change to READY or a FLUSH event (in which case this function returns GST_FLOW_FLUSHING).

This function should only be called with the PREROLL_LOCK held, like in the render function.

Parameters:

`sink` –

the sink

Returns –

GST_FLOW_OK if the preroll completed and processing can continue. Any other return value should be returned from the render vmethod.

#### GstBase.BaseSink.prototype.wait_preroll

    function GstBase.BaseSink.prototype.wait_preroll(): {
        // javascript wrapper for 'gst_base_sink_wait_preroll'
    }

If the vfunc_render method performs its own synchronisation against the clock it must unblock when going from PLAYING to the PAUSED state and call this method before continuing to render the remaining data.

If the vfunc_render method can block on something else than the clock, it must also be ready to unblock immediately on the vfunc_unlock method and cause the vfunc_render method to immediately call this function. In this case, the subclass must be prepared to continue rendering where it left off if this function returns Gst.FlowReturn.OK.

This function will block until a state change to PLAYING happens (in which case this function returns Gst.FlowReturn.OK) or the processing must be stopped due to a state change to READY or a FLUSH event (in which case this function returns Gst.FlowReturn.FLUSHING).

This function should only be called with the PREROLL_LOCK held, like in the render function.

Parameters:

`sink` (GstBase.BaseSink) –

the sink

Returns (Gst.FlowReturn) –

Gst.FlowReturn.OK if the preroll completed and processing can continue. Any other return value should be returned from the render vmethod.

#### GstBase.BaseSink.wait_preroll

    def GstBase.BaseSink.wait_preroll (self):
        #python wrapper for 'gst_base_sink_wait_preroll'

If the do_render method performs its own synchronisation against the clock it must unblock when going from PLAYING to the PAUSED state and call this method before continuing to render the remaining data.

If the do_render method can block on something else than the clock, it must also be ready to unblock immediately on the do_unlock method and cause the do_render method to immediately call this function. In this case, the subclass must be prepared to continue rendering where it left off if this function returns Gst.FlowReturn.OK.

This function will block until a state change to PLAYING happens (in which case this function returns Gst.FlowReturn.OK) or the processing must be stopped due to a state change to READY or a FLUSH event (in which case this function returns Gst.FlowReturn.FLUSHING).

This function should only be called with the PREROLL_LOCK held, like in the render function.

Parameters:

`sink` (GstBase.BaseSink) –

the sink

Returns (Gst.FlowReturn) –

Gst.FlowReturn.OK if the preroll completed and processing can continue. Any other return value should be returned from the render vmethod.

### Properties

#### async

    “async” gboolean

If set to TRUE, the basesink will perform asynchronous state changes. When set to FALSE, the sink will not signal the parent when it prerolls. Use this option when dealing with sparse streams or when synchronisation is not required.

Flags : Read / Write

#### async

    “async” Number

If set to true, the basesink will perform asynchronous state changes. When set to false, the sink will not signal the parent when it prerolls. Use this option when dealing with sparse streams or when synchronisation is not required.

Flags : Read / Write

#### async

    “self.props.async” bool

If set to True, the basesink will perform asynchronous state changes. When set to False, the sink will not signal the parent when it prerolls. Use this option when dealing with sparse streams or when synchronisation is not required.

Flags : Read / Write

#### blocksize

    “blocksize” guint

The amount of bytes to pull when operating in pull mode.

Flags : Read / Write

#### blocksize

    “blocksize” Number

The amount of bytes to pull when operating in pull mode.

Flags : Read / Write

#### blocksize

    “self.props.blocksize” int

The amount of bytes to pull when operating in pull mode.

Flags : Read / Write

#### enable-last-sample

    “enable-last-sample” gboolean

Enable the last-sample property. If FALSE, basesink doesn't keep a reference to the last buffer arrived and the last-sample property is always set to NULL. This can be useful if you need buffers to be released as soon as possible, eg. if you're using a buffer pool.

Flags : Read / Write

#### enable-last-sample

    “enable-last-sample” Number

Enable the last-sample property. If false, basesink doesn't keep a reference to the last buffer arrived and the last-sample property is always set to null. This can be useful if you need buffers to be released as soon as possible, eg. if you're using a buffer pool.

Flags : Read / Write

#### enable_last_sample

    “self.props.enable_last_sample” bool

Enable the last-sample property. If False, basesink doesn't keep a reference to the last buffer arrived and the last-sample property is always set to None. This can be useful if you need buffers to be released as soon as possible, eg. if you're using a buffer pool.

Flags : Read / Write

#### last-sample

    “last-sample” GstSample *

The last buffer that arrived in the sink and was used for preroll or for rendering. This property can be used to generate thumbnails. This property can be NULL when the sink has not yet received a buffer.

Flags : Read

#### last-sample

    “last-sample” Gst.Sample

The last buffer that arrived in the sink and was used for preroll or for rendering. This property can be used to generate thumbnails. This property can be null when the sink has not yet received a buffer.

Flags : Read

#### last_sample

    “self.props.last_sample” Gst.Sample

The last buffer that arrived in the sink and was used for preroll or for rendering. This property can be used to generate thumbnails. This property can be None when the sink has not yet received a buffer.

Flags : Read

#### max-bitrate

    “max-bitrate” guint64

Control the maximum amount of bits that will be rendered per second. Setting this property to a value bigger than 0 will make the sink delay rendering of the buffers when it would exceed to max-bitrate.

Flags : Read / Write

Since : 1.2

#### max-bitrate

    “max-bitrate” Number

Control the maximum amount of bits that will be rendered per second. Setting this property to a value bigger than 0 will make the sink delay rendering of the buffers when it would exceed to max-bitrate.

Flags : Read / Write

Since : 1.2

#### max_bitrate

    “self.props.max_bitrate” int

Control the maximum amount of bits that will be rendered per second. Setting this property to a value bigger than 0 will make the sink delay rendering of the buffers when it would exceed to max-bitrate.

Flags : Read / Write

Since : 1.2

#### max-lateness

    “max-lateness” gint64

Flags : Read / Write

#### max-lateness

    “max-lateness” Number

Flags : Read / Write

#### max_lateness

    “self.props.max_lateness” int

Flags : Read / Write

#### processing-deadline

    “processing-deadline” guint64

Maximum amount of time (in nanoseconds) that the pipeline can take for processing the buffer. This is added to the latency of live pipelines.

Flags : Read / Write

Since : 1.16

#### processing-deadline

    “processing-deadline” Number

Maximum amount of time (in nanoseconds) that the pipeline can take for processing the buffer. This is added to the latency of live pipelines.

Flags : Read / Write

Since : 1.16

#### processing_deadline

    “self.props.processing_deadline” int

Maximum amount of time (in nanoseconds) that the pipeline can take for processing the buffer. This is added to the latency of live pipelines.

Flags : Read / Write

Since : 1.16

#### qos

    “qos” gboolean

Flags : Read / Write

#### qos

    “qos” Number

Flags : Read / Write

#### qos

    “self.props.qos” bool

Flags : Read / Write

#### render-delay

    “render-delay” guint64

The additional delay between synchronisation and actual rendering of the media. This property will add additional latency to the device in order to make other sinks compensate for the delay.

Flags : Read / Write

#### render-delay

    “render-delay” Number

The additional delay between synchronisation and actual rendering of the media. This property will add additional latency to the device in order to make other sinks compensate for the delay.

Flags : Read / Write

#### render_delay

    “self.props.render_delay” int

The additional delay between synchronisation and actual rendering of the media. This property will add additional latency to the device in order to make other sinks compensate for the delay.

Flags : Read / Write

#### stats

    “stats” GstStructure *

Various GstBaseSink statistics. This property returns a GstStructure with name `application/x-gst-base-sink-stats` with the following fields:

- "average-rate" G_TYPE_DOUBLE average frame rate
- "dropped" G_TYPE_UINT64 Number of dropped frames
- "rendered" G_TYPE_UINT64 Number of rendered frames

Flags : Read

Since : 1.18

#### stats

    “stats” Gst.Structure

Various GstBase.BaseSink statistics. This property returns a Gst.Structure with name `application/x-gst-base-sink-stats` with the following fields:

- "average-rate" G_TYPE_DOUBLE average frame rate
- "dropped" G_TYPE_UINT64 Number of dropped frames
- "rendered" G_TYPE_UINT64 Number of rendered frames

Flags : Read

Since : 1.18

#### stats

    “self.props.stats” Gst.Structure

Various GstBase.BaseSink statistics. This property returns a Gst.Structure with name `application/x-gst-base-sink-stats` with the following fields:

- "average-rate" G_TYPE_DOUBLE average frame rate
- "dropped" G_TYPE_UINT64 Number of dropped frames
- "rendered" G_TYPE_UINT64 Number of rendered frames

Flags : Read

Since : 1.18

#### sync

    “sync” gboolean

Flags : Read / Write

#### sync

    “sync” Number

Flags : Read / Write

#### sync

    “self.props.sync” bool

Flags : Read / Write

#### throttle-time

    “throttle-time” guint64

The time to insert between buffers. This property can be used to control the maximum amount of buffers per second to render. Setting this property to a value bigger than 0 will make the sink create THROTTLE QoS events.

Flags : Read / Write

#### throttle-time

    “throttle-time” Number

The time to insert between buffers. This property can be used to control the maximum amount of buffers per second to render. Setting this property to a value bigger than 0 will make the sink create THROTTLE QoS events.

Flags : Read / Write

#### throttle_time

    “self.props.throttle_time” int

The time to insert between buffers. This property can be used to control the maximum amount of buffers per second to render. Setting this property to a value bigger than 0 will make the sink create THROTTLE QoS events.

Flags : Read / Write

#### ts-offset

    “ts-offset” gint64

Controls the final synchronisation, a negative value will render the buffer earlier while a positive value delays playback. This property can be used to fix synchronisation in bad files.

Flags : Read / Write

#### ts-offset

    “ts-offset” Number

Controls the final synchronisation, a negative value will render the buffer earlier while a positive value delays playback. This property can be used to fix synchronisation in bad files.

Flags : Read / Write

#### ts_offset

    “self.props.ts_offset” int

Controls the final synchronisation, a negative value will render the buffer earlier while a positive value delays playback. This property can be used to fix synchronisation in bad files.

Flags : Read / Write

### Virtual Methods

#### activate_pull

    gboolean
    activate_pull (GstBaseSink * sink,
                   gboolean active)

Subclasses should override this when they can provide an alternate method of spawning a thread to drive the pipeline in pull mode. Should start or stop the pulling thread, depending on the value of the "active" argument. Called after actually activating the sink pad in pull mode. The default implementation starts a task on the sink pad.

Parameters:

`sink` –
No description available
`active` –
No description available
Returns –
No description available

#### vfunc_activate_pull

    function vfunc_activate_pull(sink: GstBase.BaseSink, active: Number): {
        // javascript implementation of the 'activate_pull' virtual method
    }

Subclasses should override this when they can provide an alternate method of spawning a thread to drive the pipeline in pull mode. Should start or stop the pulling thread, depending on the value of the "active" argument. Called after actually activating the sink pad in pull mode. The default implementation starts a task on the sink pad.

Parameters:

`sink` (GstBase.BaseSink) –
No description available
`active` (Number) –
No description available
Returns (Number) –
No description available

#### do_activate_pull

    def do_activate_pull (sink, active):
        #python implementation of the 'activate_pull' virtual method

Subclasses should override this when they can provide an alternate method of spawning a thread to drive the pipeline in pull mode. Should start or stop the pulling thread, depending on the value of the "active" argument. Called after actually activating the sink pad in pull mode. The default implementation starts a task on the sink pad.

Parameters:

`sink` (GstBase.BaseSink) –
No description available
`active` (bool) –
No description available
Returns (bool) –
No description available

#### event

    gboolean
    event (GstBaseSink * sink,
           GstEvent * event)

Override this to handle events arriving on the sink pad

Parameters:

`sink` –
No description available
`event` –
No description available
Returns –
No description available

#### vfunc_event

    function vfunc_event(sink: GstBase.BaseSink, event: Gst.Event): {
        // javascript implementation of the 'event' virtual method
    }

Override this to handle events arriving on the sink pad

Parameters:

`sink` (GstBase.BaseSink) –
No description available
`event` (Gst.Event) –
No description available
Returns (Number) –
No description available

#### do_event

    def do_event (sink, event):
        #python implementation of the 'event' virtual method

Override this to handle events arriving on the sink pad

Parameters:

`sink` (GstBase.BaseSink) –
No description available
`event` (Gst.Event) –
No description available
Returns (bool) –
No description available

#### fixate

    GstCaps *
    fixate (GstBaseSink * sink,
            GstCaps * caps)

Only useful in pull mode. Implement if you have ideas about what should be the default values for the caps you support.

Parameters:

`sink` –
No description available
`caps` –
No description available
Returns –
No description available

#### vfunc_fixate

    function vfunc_fixate(sink: GstBase.BaseSink, caps: Gst.Caps): {
        // javascript implementation of the 'fixate' virtual method
    }

Only useful in pull mode. Implement if you have ideas about what should be the default values for the caps you support.

Parameters:

`sink` (GstBase.BaseSink) –
No description available
`caps` (Gst.Caps) –
No description available
Returns (Gst.Caps) –
No description available

#### do_fixate

    def do_fixate (sink, caps):
        #python implementation of the 'fixate' virtual method

Only useful in pull mode. Implement if you have ideas about what should be the default values for the caps you support.

Parameters:

`sink` (GstBase.BaseSink) –
No description available
`caps` (Gst.Caps) –
No description available
Returns (Gst.Caps) –
No description available

#### get_caps

    GstCaps *
    get_caps (GstBaseSink * sink,
              GstCaps * filter)

Called to get sink pad caps from the subclass

Parameters:

`sink` –
No description available
`filter` –
No description available
Returns –
No description available

#### vfunc_get_caps

    function vfunc_get_caps(sink: GstBase.BaseSink, filter: Gst.Caps): {
        // javascript implementation of the 'get_caps' virtual method
    }

Called to get sink pad caps from the subclass

Parameters:

`sink` (GstBase.BaseSink) –
No description available
`filter` (Gst.Caps) –
No description available
Returns (Gst.Caps) –
No description available

#### do_get_caps

    def do_get_caps (sink, filter):
        #python implementation of the 'get_caps' virtual method

Called to get sink pad caps from the subclass

Parameters:

`sink` (GstBase.BaseSink) –
No description available
`filter` (Gst.Caps) –
No description available
Returns (Gst.Caps) –
No description available

#### get_times

    get_times (GstBaseSink * sink,
               GstBuffer * buffer,
               GstClockTime * start,
               GstClockTime * end)

Called to get the start and end times for synchronising the passed buffer to the clock

Parameters:

`sink` –
No description available
`buffer` –
No description available
`start` –
No description available
`end` –
No description available

#### vfunc_get_times

    function vfunc_get_times(sink: GstBase.BaseSink, buffer: Gst.Buffer): {
        // javascript implementation of the 'get_times' virtual method
    }

Called to get the start and end times for synchronising the passed buffer to the clock

Parameters:

`sink` (GstBase.BaseSink) –
No description available
`buffer` (Gst.Buffer) –
No description available

#### do_get_times

    def do_get_times (sink, buffer):
        #python implementation of the 'get_times' virtual method

Called to get the start and end times for synchronising the passed buffer to the clock

Parameters:

`sink` (GstBase.BaseSink) –
No description available
`buffer` (Gst.Buffer) –
No description available

#### prepare

    GstFlowReturn
    prepare (GstBaseSink * sink,
             GstBuffer * buffer)

Called to prepare the buffer for render and preroll. This function is called before synchronisation is performed.

Parameters:

`sink` –
No description available
`buffer` –
No description available
Returns –
No description available

#### vfunc_prepare

    function vfunc_prepare(sink: GstBase.BaseSink, buffer: Gst.Buffer): {
        // javascript implementation of the 'prepare' virtual method
    }

Called to prepare the buffer for render and preroll. This function is called before synchronisation is performed.

Parameters:

`sink` (GstBase.BaseSink) –
No description available
`buffer` (Gst.Buffer) –
No description available
Returns (Gst.FlowReturn) –
No description available

#### do_prepare

    def do_prepare (sink, buffer):
        #python implementation of the 'prepare' virtual method

Called to prepare the buffer for render and preroll. This function is called before synchronisation is performed.

Parameters:

`sink` (GstBase.BaseSink) –
No description available
`buffer` (Gst.Buffer) –
No description available
Returns (Gst.FlowReturn) –
No description available

#### prepare_list

    GstFlowReturn
    prepare_list (GstBaseSink * sink,
                  GstBufferList * buffer_list)

Called to prepare the buffer list for render_list. This function is called before synchronisation is performed.

Parameters:

`sink` –
No description available
`buffer_list` –
No description available
Returns –
No description available

#### vfunc_prepare_list

    function vfunc_prepare_list(sink: GstBase.BaseSink, buffer_list: Gst.BufferList): {
        // javascript implementation of the 'prepare_list' virtual method
    }

Called to prepare the buffer list for render_list. This function is called before synchronisation is performed.

Parameters:

`sink` (GstBase.BaseSink) –
No description available
`buffer_list` (Gst.BufferList) –
No description available
Returns (Gst.FlowReturn) –
No description available

#### do_prepare_list

    def do_prepare_list (sink, buffer_list):
        #python implementation of the 'prepare_list' virtual method

Called to prepare the buffer list for render_list. This function is called before synchronisation is performed.

Parameters:

`sink` (GstBase.BaseSink) –
No description available
`buffer_list` (Gst.BufferList) –
No description available
Returns (Gst.FlowReturn) –
No description available

#### preroll

    GstFlowReturn
    preroll (GstBaseSink * sink,
             GstBuffer * buffer)

Called to present the preroll buffer if desired.

Parameters:

`sink` –
No description available
`buffer` –
No description available
Returns –
No description available

#### vfunc_preroll

    function vfunc_preroll(sink: GstBase.BaseSink, buffer: Gst.Buffer): {
        // javascript implementation of the 'preroll' virtual method
    }

Called to present the preroll buffer if desired.

Parameters:

`sink` (GstBase.BaseSink) –
No description available
`buffer` (Gst.Buffer) –
No description available
Returns (Gst.FlowReturn) –
No description available

#### do_preroll

    def do_preroll (sink, buffer):
        #python implementation of the 'preroll' virtual method

Called to present the preroll buffer if desired.

Parameters:

`sink` (GstBase.BaseSink) –
No description available
`buffer` (Gst.Buffer) –
No description available
Returns (Gst.FlowReturn) –
No description available

#### propose_allocation

    gboolean
    propose_allocation (GstBaseSink * sink,
                        GstQuery * query)

configure the allocation query

Parameters:

`sink` –
No description available
`query` –
No description available
Returns –
No description available

#### vfunc_propose_allocation

    function vfunc_propose_allocation(sink: GstBase.BaseSink, query: Gst.Query): {
        // javascript implementation of the 'propose_allocation' virtual method
    }

configure the allocation query

Parameters:

`sink` (GstBase.BaseSink) –
No description available
`query` (Gst.Query) –
No description available
Returns (Number) –
No description available

#### do_propose_allocation

    def do_propose_allocation (sink, query):
        #python implementation of the 'propose_allocation' virtual method

configure the allocation query

Parameters:

`sink` (GstBase.BaseSink) –
No description available
`query` (Gst.Query) –
No description available
Returns (bool) –
No description available

#### query

    gboolean
    query (GstBaseSink * sink,
           GstQuery * query)

perform a GstQuery on the element.

Parameters:

`sink` –
No description available
`query` –
No description available
Returns –
No description available

#### vfunc_query

    function vfunc_query(sink: GstBase.BaseSink, query: Gst.Query): {
        // javascript implementation of the 'query' virtual method
    }

perform a Gst.Query on the element.

Parameters:

`sink` (GstBase.BaseSink) –
No description available
`query` (Gst.Query) –
No description available
Returns (Number) –
No description available

#### do_query

    def do_query (sink, query):
        #python implementation of the 'query' virtual method

perform a Gst.Query on the element.

Parameters:

`sink` (GstBase.BaseSink) –
No description available
`query` (Gst.Query) –
No description available
Returns (bool) –
No description available

#### render

    GstFlowReturn
    render (GstBaseSink * sink,
            GstBuffer * buffer)

Called when a buffer should be presented or output, at the correct moment if the GstBaseSink has been set to sync to the clock.

Parameters:

`sink` –
No description available
`buffer` –
No description available
Returns –
No description available

#### vfunc_render

    function vfunc_render(sink: GstBase.BaseSink, buffer: Gst.Buffer): {
        // javascript implementation of the 'render' virtual method
    }

Called when a buffer should be presented or output, at the correct moment if the GstBase.BaseSink has been set to sync to the clock.

Parameters:

`sink` (GstBase.BaseSink) –
No description available
`buffer` (Gst.Buffer) –
No description available
Returns (Gst.FlowReturn) –
No description available

#### do_render

    def do_render (sink, buffer):
        #python implementation of the 'render' virtual method

Called when a buffer should be presented or output, at the correct moment if the GstBase.BaseSink has been set to sync to the clock.

Parameters:

`sink` (GstBase.BaseSink) –
No description available
`buffer` (Gst.Buffer) –
No description available
Returns (Gst.FlowReturn) –
No description available

#### render_list

    GstFlowReturn
    render_list (GstBaseSink * sink,
                 GstBufferList * buffer_list)

Same as render but used with buffer lists instead of buffers.

Parameters:

`sink` –
No description available
`buffer_list` –
No description available
Returns –
No description available

#### vfunc_render_list

    function vfunc_render_list(sink: GstBase.BaseSink, buffer_list: Gst.BufferList): {
        // javascript implementation of the 'render_list' virtual method
    }

Same as render but used with buffer lists instead of buffers.

Parameters:

`sink` (GstBase.BaseSink) –
No description available
`buffer_list` (Gst.BufferList) –
No description available
Returns (Gst.FlowReturn) –
No description available

#### do_render_list

    def do_render_list (sink, buffer_list):
        #python implementation of the 'render_list' virtual method

Same as render but used with buffer lists instead of buffers.

Parameters:

`sink` (GstBase.BaseSink) –
No description available
`buffer_list` (Gst.BufferList) –
No description available
Returns (Gst.FlowReturn) –
No description available

#### set_caps

    gboolean
    set_caps (GstBaseSink * sink,
              GstCaps * caps)

Notify subclass of changed caps

Parameters:

`sink` –
No description available
`caps` –
No description available
Returns –
No description available

#### vfunc_set_caps

    function vfunc_set_caps(sink: GstBase.BaseSink, caps: Gst.Caps): {
        // javascript implementation of the 'set_caps' virtual method
    }

Notify subclass of changed caps

Parameters:

`sink` (GstBase.BaseSink) –
No description available
`caps` (Gst.Caps) –
No description available
Returns (Number) –
No description available

#### do_set_caps

    def do_set_caps (sink, caps):
        #python implementation of the 'set_caps' virtual method

Notify subclass of changed caps

Parameters:

`sink` (GstBase.BaseSink) –
No description available
`caps` (Gst.Caps) –
No description available
Returns (bool) –
No description available

#### start

    gboolean
    start (GstBaseSink * sink)

Start processing. Ideal for opening resources in the subclass

Parameters:

`sink` –
No description available
Returns –
No description available

#### vfunc_start

    function vfunc_start(sink: GstBase.BaseSink): {
        // javascript implementation of the 'start' virtual method
    }

Start processing. Ideal for opening resources in the subclass

Parameters:

`sink` (GstBase.BaseSink) –
No description available
Returns (Number) –
No description available

#### do_start

    def do_start (sink):
        #python implementation of the 'start' virtual method

Start processing. Ideal for opening resources in the subclass

Parameters:

`sink` (GstBase.BaseSink) –
No description available
Returns (bool) –
No description available

#### stop

    gboolean
    stop (GstBaseSink * sink)

Stop processing. Subclasses should use this to close resources.

Parameters:

`sink` –
No description available
Returns –
No description available

#### vfunc_stop

    function vfunc_stop(sink: GstBase.BaseSink): {
        // javascript implementation of the 'stop' virtual method
    }

Stop processing. Subclasses should use this to close resources.

Parameters:

`sink` (GstBase.BaseSink) –
No description available
Returns (Number) –
No description available

#### do_stop

    def do_stop (sink):
        #python implementation of the 'stop' virtual method

Stop processing. Subclasses should use this to close resources.

Parameters:

`sink` (GstBase.BaseSink) –
No description available
Returns (bool) –
No description available

#### unlock

    gboolean
    unlock (GstBaseSink * sink)

Unlock any pending access to the resource. Subclasses should unblock any blocked function ASAP and call gst_base_sink_wait_preroll

Parameters:

`sink` –
No description available
Returns –
No description available

#### vfunc_unlock

    function vfunc_unlock(sink: GstBase.BaseSink): {
        // javascript implementation of the 'unlock' virtual method
    }

Unlock any pending access to the resource. Subclasses should unblock any blocked function ASAP and call GstBase.BaseSink.prototype.wait_preroll

Parameters:

`sink` (GstBase.BaseSink) –
No description available
Returns (Number) –
No description available

#### do_unlock

    def do_unlock (sink):
        #python implementation of the 'unlock' virtual method

Unlock any pending access to the resource. Subclasses should unblock any blocked function ASAP and call GstBase.BaseSink.wait_preroll

Parameters:

`sink` (GstBase.BaseSink) –
No description available
Returns (bool) –
No description available

#### unlock_stop

    gboolean
    unlock_stop (GstBaseSink * sink)

Clear the previous unlock request. Subclasses should clear any state they set during unlock, and be ready to continue where they left off after gst_base_sink_wait_preroll, gst_base_sink_wait or gst_wait_sink_wait_clock return or render is called again.

Parameters:

`sink` –
No description available
Returns –
No description available

#### vfunc_unlock_stop

    function vfunc_unlock_stop(sink: GstBase.BaseSink): {
        // javascript implementation of the 'unlock_stop' virtual method
    }

Clear the previous unlock request. Subclasses should clear any state they set during vfunc_unlock, and be ready to continue where they left off after GstBase.BaseSink.prototype.wait_preroll, GstBase.BaseSink.prototype.wait or gst_wait_sink_wait_clock return or vfunc_render is called again.

Parameters:

`sink` (GstBase.BaseSink) –
No description available
Returns (Number) –
No description available

#### do_unlock_stop

    def do_unlock_stop (sink):
        #python implementation of the 'unlock_stop' virtual method

Clear the previous unlock request. Subclasses should clear any state they set during do_unlock, and be ready to continue where they left off after GstBase.BaseSink.wait_preroll, GstBase.BaseSink.wait or gst_wait_sink_wait_clock return or do_render is called again.

Parameters:

`sink` (GstBase.BaseSink) –
No description available
Returns (bool) –
No description available

#### wait_event

    GstFlowReturn
    wait_event (GstBaseSink * sink,
                GstEvent * event)

Override this to implement custom logic to wait for the event time (for events like EOS and GAP). Subclasses should always first chain up to the default implementation.

Parameters:

`sink` –
No description available
`event` –
No description available
Returns –
No description available

#### vfunc_wait_event

    function vfunc_wait_event(sink: GstBase.BaseSink, event: Gst.Event): {
        // javascript implementation of the 'wait_event' virtual method
    }

Override this to implement custom logic to wait for the event time (for events like EOS and GAP). Subclasses should always first chain up to the default implementation.

Parameters:

`sink` (GstBase.BaseSink) –
No description available
`event` (Gst.Event) –
No description available
Returns (Gst.FlowReturn) –
No description available

#### do_wait_event

    def do_wait_event (sink, event):
        #python implementation of the 'wait_event' virtual method

Override this to implement custom logic to wait for the event time (for events like EOS and GAP). Subclasses should always first chain up to the default implementation.

Parameters:

`sink` (GstBase.BaseSink) –
No description available
`event` (Gst.Event) –
No description available
Returns (Gst.FlowReturn) –
No description available

## Function Macros

### GST_BASE_SINK_CAST

    #define GST_BASE_SINK_CAST(obj)         ((GstBaseSink *) (obj))

### GST_BASE_SINK_GET_PREROLL_COND

    #define GST_BASE_SINK_GET_PREROLL_COND(obj)   (&GST_BASE_SINK_CAST(obj)->preroll_cond)

### GST_BASE_SINK_GET_PREROLL_LOCK

    #define GST_BASE_SINK_GET_PREROLL_LOCK(obj)   (&GST_BASE_SINK_CAST(obj)->preroll_lock)

### GST_BASE_SINK_PAD

    #define GST_BASE_SINK_PAD(obj)          (GST_BASE_SINK_CAST (obj)->sinkpad)

Gives the pointer to the GstPad object of the element.

Parameters:

`obj` –

base sink instance

### GST_BASE_SINK_PREROLL_BROADCAST

    #define GST_BASE_SINK_PREROLL_BROADCAST(obj)  g_cond_broadcast (GST_BASE_SINK_GET_PREROLL_COND (obj));

### GST_BASE_SINK_PREROLL_LOCK

    #define GST_BASE_SINK_PREROLL_LOCK(obj)       (g_mutex_lock(GST_BASE_SINK_GET_PREROLL_LOCK(obj)))

### GST_BASE_SINK_PREROLL_SIGNAL

    #define GST_BASE_SINK_PREROLL_SIGNAL(obj)     g_cond_signal (GST_BASE_SINK_GET_PREROLL_COND (obj));

### GST_BASE_SINK_PREROLL_TRYLOCK

    #define GST_BASE_SINK_PREROLL_TRYLOCK(obj)    (g_mutex_trylock(GST_BASE_SINK_GET_PREROLL_LOCK(obj)))

### GST_BASE_SINK_PREROLL_UNLOCK

    #define GST_BASE_SINK_PREROLL_UNLOCK(obj)     (g_mutex_unlock(GST_BASE_SINK_GET_PREROLL_LOCK(obj)))

### GST_BASE_SINK_PREROLL_WAIT

    #define GST_BASE_SINK_PREROLL_WAIT(obj)       \
          g_cond_wait (GST_BASE_SINK_GET_PREROLL_COND (obj), GST_BASE_SINK_GET_PREROLL_LOCK (obj))

### GST_BASE_SINK_PREROLL_WAIT_UNTIL

    #define GST_BASE_SINK_PREROLL_WAIT_UNTIL(obj, end_time) \
          g_cond_wait_until (GST_BASE_SINK_GET_PREROLL_COND (obj), GST_BASE_SINK_GET_PREROLL_LOCK (obj), end_time)

## Constants

### GST_BASE_SINK_FLOW_DROPPED

    #define GST_BASE_SINK_FLOW_DROPPED     GST_FLOW_CUSTOM_SUCCESS

A GstFlowReturn that can be returned from render to indicate that the output buffer was not rendered.

Note that this is currently not support for render_list virtual method.

Since : 1.24

The results of the search are